package src;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList; 

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
import java.util.Iterator;
// #[regen=yes,id=DCE.A72E5DD7-A156-FB14-2A93-B0E1F8896529]
// </editor-fold> 
public class Partida {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.449431FD-1BB3-6898-5ECA-BF62B2B99FB2]
    // </editor-fold> 
    private ArrayList<Dado> dadoAta;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B7A7C9C4-8C78-1169-764F-C35C2747FF75]
    // </editor-fold> 
    private ArrayList<Dado> dadoDef;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AAD7E6C1-1036-7F57-308D-474E893A6D91]
    // </editor-fold> 
    private Tablero tablero;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AB81F2E2-1DDE-961D-29E9-10BE7ACDDD6B]
    // </editor-fold> 
    private ArrayList<Jugador> jugadores;
    
    private int turno=0;

    /**
     *  variable para gestionar los turnos
     */
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.704B1B69-82D7-67D7-941C-2CAA9FEB96FB]
    // </editor-fold> 
    public Partida () throws java.io.IOException {
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;
        
        
        
        
        System.out.println("Cuantos jugadores jugaran hoy? (2-6)");
        
        linea = teclado.readLine();
        int numJugadores = Integer.parseInt(linea);//pasamos a int el dato introducido por teclado que nos llega como String
    	
        //bucle en el que comprobamos que el numero introducido es el correcto
        while ((numJugadores < 2) || (numJugadores > 6)){
            System.out.println("Numero de jugadores incorrecto. Pruebe de nuevo.");
            System.out.println("Cuantos jugadores jugaran hoy? (2-6)");
            
            linea = teclado.readLine();
            numJugadores = Integer.parseInt(linea);
        }
        
        jugadores = new ArrayList<Jugador>(numJugadores);//creamos el array de jugadores
        for (int i=0; i < numJugadores; i++){
            System.out.println("Introduzca el nombre del jugador "+(i+1)+":");
            //Aqui implementar confirmacion de nombre, por si se equivoca al introducirlo.
           linea = teclado.readLine();
            jugadores.add(new Jugador(linea,i));
            //jugador[i].setnombre(teclado.readLine());
        }
        setJugador(jugadores);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4F6F0C3E-AB37-B9A9-E685-CABB2D1F3D76]
    // </editor-fold> 
    public ArrayList<Jugador> getJugador () {
        return jugadores;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F568669E-193B-52C1-E637-0CD07A354CC6]
    // </editor-fold> 
    public void setJugador (ArrayList<Jugador> val) {
        jugadores = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E36CBC13-E609-242B-94E7-4E12D110E79B]
    // </editor-fold> 
    public Tablero getTablero () {
        return tablero;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0D1D7706-642D-57EF-2648-DF15DC30B9CC]
    // </editor-fold> 
    public void setTablero (Tablero val) {
        tablero = val;
    }

    public void jugar() throws IOException{
        char accion = 'a';//variable que contiene la accion del menu escogida por el jugador
        int i = 0;
        //comprobar q sean creado todos los paises y sus adyacentes
//        ArrayList<Territorio> ter = tablero.getTerritorio();
//        ArrayList<Territorio> ady;
//        Iterator it = ter.iterator();
//        Iterator it2;
//        System.out.println("territorios:");
//        while(it.hasNext()){
//            Territorio t = (Territorio) it.next();
//            System.out.println(t.getNombreTerritorio());
//            ady = t.getTerritoriosAdy();
//            if (ady != null){
//                it2 = ady.iterator();
//                while(it2.hasNext()){
//                    Territorio terr = (Territorio) it2.next();
//                    System.out.println("\t"+terr.getNombreTerritorio());
//                }
//            }
//        }
//        //comprobar que se han creado los continente y que estos contienen sus territorios
//        ArrayList<Continente> ter = tablero.getContinente();
//        ArrayList<Territorio> ady;
//        Iterator it = ter.iterator();
//        Iterator it2;
//        System.out.println("continentes:");
//        while(it.hasNext()){
//            Continente t = (Continente) it.next();
//            System.out.println(t.getNombreContinente());
//            ady = t.getTerritorio();
//            if (ady != null){
//                it2 = ady.iterator();
//                while(it2.hasNext()){
//                    Territorio terr = (Territorio) it2.next();
//                    System.out.println("\t"+terr.getNombreTerritorio());
//                }
//            }
//        }
             
        System.out.println("Empieza el juego!");
        while (accion != 'q'){
            System.out.println("Comienza el turno "+(turno+1)+":");
            i = 0;
            while (i < jugadores.size() && accion != 'q'){
                accion='a';//inicializamos la variable para que pueda entrar en el bucle
                //bucle del cual se sale si pulsamos la opcion 'f' o la opcion 'q'
                //si pulsamos 'a' podremos seguir atacando
                while((accion == 'a' || accion == 'v' || accion == 'c') && (accion != 'f' || accion != 'q') ){
                    System.out.println(jugadores.get(i).getNombreJugador()+", es tu turno!");
                    accion = jugadores.get(i).jugarTurno();
                    if (accion == 'a') atacar(jugadores.get(i));
                    if (accion == 'v') System.out.println("accion de ver carta aun no disponible");
                    if (accion == 'c') System.out.println("accion de cambiar carta aun no disponible");
                    if (accion == 'f')  System.out.println(jugadores.get(i).getNombreJugador()+" termina su turno.");
                }
                i++;
            }
            turno++;
        }
        System.out.println("Fin de partida");
    }
    
    public void atacar(Jugador jug){
        System.out.println(jug.getNombreJugador()+" está atacando!");
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7FC02710-A1D8-5DCD-619E-A75D758F0EDF]
    // </editor-fold> 
    public ArrayList<Dado> getDadoAta () {
        return dadoAta;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9ADF3BB9-C929-68D5-964D-D88495E949A6]
    // </editor-fold> 
    public void setDadoAta (ArrayList<Dado> val) {
        this.dadoAta = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8B41B990-BC24-21A8-955A-6D2666E3A668]
    // </editor-fold> 
    public ArrayList<Dado> getDadoDef () {
        return dadoDef;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.37579365-5AB8-C002-7049-FA66B4E92BB5]
    // </editor-fold> 
    public void setDadoDef (ArrayList<Dado> val) {
        this.dadoDef = val;
    }
}

